## mingw-w64-dosbox-staging-0.82.1-1.src.tar.zst

=== src/CMakeLists.txt ===
add_subdirectory(capture)
add_subdirectory(cpu)
add_subdirectory(debug)
add_subdirectory(dos)
add_subdirectory(fpu)
add_subdirectory(gui)
add_subdirectory(hardware)
add_subdirectory(ints)
add_subdirectory(libs)
add_subdirectory(midi)
add_subdirectory(misc)
add_subdirectory(shell)
