=== src/libs/whereami/CMakeLists.txt ===
add_library(libwhereami STATIC whereami.c)
target_include_directories(libwhereami PUBLIC .)
