=== src/hardware/reelmagic/tools/Makefile ===
## Copyright (C) 2022 Jon Dennis
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

CFLAGS :=

ifeq ($(ENABLE_WINCOMPAT),1) 
  CFLAGS := -include wincompat.h
else
  CFLAGS :=
endif

OUTPUTS := $(patsubst %.c,%,$(wildcard *.c))
OUTPUTS_EXE := $(patsubst %.c,%.exe,$(wildcard *.c))

HEADERS := $(wildcard *.h)

.PHONY: all clean

all:
	$(MAKE) $(OUTPUTS)

clean: 
	rm -f $(OUTPUTS) $(OUTPUTS_EXE)

%: %.c $(HEADERS)
	$(CC) $(CFLAGS) -O3 -Wall -s -o "$@" "$<"
