=== contrib/linux/debian/control ===
Source: dosbox-staging
Section: otherosfs
Priority: optional
Maintainer: The DOSBox Staging Team <join.discord.with.WwAg3Xf@discord.gg>
Build-Depends: Populated by scripts/build-debian-package.sh
Standards-Version: 4.5.0
Homepage: https://www.dosbox-staging.org

Package: dosbox-staging
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: DOSBox Staging is a modern continuation of DOSBox
 It includes advanced features and the team uses current
 development practices. It is a (mostly) drop-in replacement
 for older DOSBox versions --- your existing configurations will
 continue to work, and you will have access to many advanced
 features.
